#pragma once

#include <limits>

// function exported to Game Maker
#define gmexport extern "C" __declspec (dllexport)

// gm_cast - cast without throwing exceptions
template<typename A>
inline A gm_cast(double d) {
	A minval = std::numeric_limits<A>::min();
	A maxval = std::numeric_limits<A>::max();
	if(d<(double)(minval)) {
		return minval;
	}
	if(d>(double)(maxval)) {
		return maxval;
	}
	return (A)(d);
}
template<>
inline float gm_cast<float>(double d) {
	float minval = -std::numeric_limits<float>::max();
	float maxval = std::numeric_limits<float>::max();
	if(d<(double)(minval)) {
		return minval;
	}
	if(d>(double)(maxval)) {
		return maxval;
	}
	return (float)(d);
}
template<>
inline double gm_cast<double>(double d) {
	return d;
}
template<>
inline bool gm_cast<bool>(double d) {
	return (d>=0.5);
}

